<script setup lang="ts">
import { reactive, ref, onMounted, computed } from 'vue';
import axios from 'axios';
import { genFileId } from 'element-plus';
import type { UploadInstance, UploadProps, UploadRawFile } from 'element-plus';
import * as echarts from 'echarts';

const upload = ref<UploadInstance>();
const handleExceed: UploadProps['onExceed'] = (files) => {
  upload.value!.clearFiles();
  const file = files[0] as UploadRawFile;
  file.uid = genFileId();
  upload.value!.handleStart(file);
};

const data = ref({});
// const data = ref({'name': ['方位名词', '能愿动词', '疑问代词', '人称代词', '指示代词', '数词', '名量词', '程度副词', '范围、协同副词', '时间副词', '频率、重复副词', '关联副词', '否定副词', '引出时间、处所', '引出对象', '连接词或词组', '结构助词', '动态助词', '语气助词', '形容词重叠', '动量词', '时量词', '方式副词', '情态副词', '语气副词', '引出方向、路径', '引出目的、原因', '连接分句或句子', '助词', '其他助词', '叹词', '离合词', '引出施事、受事', '表示排除', '引出凭借、依据', '拟声词', '借用量词'], '千分比': [3.59, 6.65, 2.33, 3.43, 8.37, 14.39, 14.51, 6.67, 2.8, 3.64, 1.0, 4.18, 8.75, 2.05, 2.5, 0.28, 8.82, 4.2, 0.12, 1.0, 2.4, 4.18, 0.16, 0.19, 0.98, 0.19, 1.28, 2.57, 0.96, 0.26, 0.0, 0.19, 0.75, 0.02, 0.21, 0.0, 0.33]});

const names = computed(() => {
  return Object.keys(data.value);
});

const keys = ['千分比'];

// const chartData = computed(() => {
//   const res = { 'f0.5': [], 'precision': [], 'recall': [] };
//   names.value.forEach((name) => {
//     keys.forEach((key: string) => {
//       res[key].push(data.value[name][key])
//     })
//   })
//   return res;
// })

var myChart: any;

const initChart = () => {
  var option = {
    tooltip: {
      trigger: 'axis',
      axisPointer: {
        type: 'shadow',
        label: {
          show: true,
        },
      },
    },
    legend: {},
    // grid: {
    //   top: '12%',
    //   left: '1%',
    //   right: '10%',
    //   containLabel: true,
    // },
    xAxis: [
      {
        type: 'category',
        data: data.value.name,
        axisLabel: {
          rotate: 45,
        },
      },
    ],
    yAxis: [
      {
        type: 'value',
        minInterval: 0.1,
      },
    ],
    series: [
      {
        name: keys[0],
        type: 'bar',
        data: data.value[keys[0]],
      },
      // {
      //   name: keys[1],
      //   type: 'bar',
      //   data: data.value[keys[1]],
      // },
      // {
      //   name: keys[2],
      //   type: 'bar',
      //   data: data.value[keys[2]],
      // },
    ],
  };
  myChart.setOption(option);
  option && myChart.setOption(option);
};
onMounted(() => {
  var chartDom = document.getElementById('chartRef') as HTMLElement;
  myChart = echarts.init(chartDom);
  // initChart();
});

const GLEU = ref();
const PTM2 = ref();

const submit = () => {
  // initChart();
  myChart.showLoading();
  axios.get('/api/dataset_evaluate').then((res) => {
    console.log(res);
    const table = res.data;
    data.value = table;
    initChart();
    myChart.hideLoading();
  });
}

const get_example_data = () => {
// initChart();
myChart.showLoading();
axios.get('/api/dataset_evaluate_example').then((res) => {
  console.log(res);
  const table = res.data;
  data.value = table;
  initChart();
  myChart.hideLoading();
});
};
</script>

<template>
  <el-row type="flex" justify="space-around" style="margin-top: 20px">
    <el-upload
      ref="upload"
      class="upload-demo"
      action="/api/upload_dataset"
      :limit="1"
      :on-exceed="handleExceed"
    >
      <template #trigger>
        <el-button type="primary">上传数据集</el-button>
      </template>
      <template #tip>
        <div class="el-upload__tip text-red">
          M2标注文件或每行以tab分割的原文本-正确文本对齐文件
          <a href="http://cgecdemo.shuishan.net.cn/api/download_dataset" download >下载示例1</a>
          <a href="http://cgecdemo.shuishan.net.cn/api/download_dataset2" download >下载示例2</a>
        </div>
      </template>
    </el-upload>
    <div class="btn-wrap">
      <el-button block @click="submit">提交</el-button>
      <el-button type="text" size="small" style="display: block;" @click="get_example_data">运行示例文件</el-button>
    </div>
  </el-row>
  <div id="chartRef"></div>
  <!-- {{ names }} -->
  <!-- <div>{{ chartData }}</div> -->
  <div v-if="GLEU" class="GLEU">GLEU: {{ GLEU }}</div>
  <div v-if="PTM2" class="PTM2">PT-M2: {{ PTM2 }}</div>
</template>

<style scoped lang="scss">
#chartRef {
  height: 500px;
}

.btn-wrap {
  display: flex;
  flex-direction: column;
  button {
    margin: 0px 0 3px;
  }
}

</style>
